#Fengyun 2G Visible and IR channel 5km resolution import routine
        
from tkinter import *
from tkinter.filedialog import askdirectory
from tkinter.filedialog import askopenfilename
from tkinter.ttk import Progressbar, Style
import shutil
import sys, os
import ilwis
import glob
import subprocess
from threading import Thread
import numpy as np
import gzip
import h5py

#passing parameters from sub menu

def execute(GNCDir, InFileName, WorkDir, OutFileName):
    if len(GNCDir) > 0 and len(InFileName) > 0 and len(WorkDir) > 0 and len(OutFileName) > 0:

        progress['value'] = 0
                
        time_stamp = InFileName

        os.chdir(WorkDir)
        ilwis.setWorkingCatalog(WorkDir)
        
        #filename = Z_SATE_C_BABJ_20250126050000_O_FY2G_FDI_IR*_001_NOM.HDF.gz for ir1 to ir4
        #filename = Z_SATE_C_BABJ_20250126050000_O_FY2G_FDI_VIS_001_NOM.HDF.gz
        for fnames in glob.glob(os.path.join(GNCDir+'/Z_SATE_C_BABJ_'+str(time_stamp)+'00_O_FY2G_FDI_IR*_001_NOM.HDF.gz')):
            shutil.copy(fnames, WorkDir)
        for fnames in glob.glob(os.path.join(GNCDir+'/Z_SATE_C_BABJ_'+str(time_stamp)+'00_O_FY2G_FDI_VIS_001_NOM.HDF.gz')):
            shutil.copy(fnames, WorkDir)

        progress['value'] = 20        
            
        def extract_gz(file_path, output_path):
            with gzip.open(file_path, 'rb') as f_in:
                with open(output_path, 'wb') as f_out:
                    shutil.copyfileobj(f_in, f_out)
                    
        #Extracting file
        extract_gz(WorkDir+'/Z_SATE_C_BABJ_'+str(time_stamp)+'00_O_FY2G_FDI_VIS_001_NOM.HDF.gz', WorkDir+'/FY_VIS_5km.hdf')
        extract_gz(WorkDir+'/Z_SATE_C_BABJ_'+str(time_stamp)+'00_O_FY2G_FDI_IR1_001_NOM.HDF.gz', WorkDir+'/FY_IR1_5km.hdf')
        extract_gz(WorkDir+'/Z_SATE_C_BABJ_'+str(time_stamp)+'00_O_FY2G_FDI_IR2_001_NOM.HDF.gz', WorkDir+'/FY_IR2_5km.hdf')
        extract_gz(WorkDir+'/Z_SATE_C_BABJ_'+str(time_stamp)+'00_O_FY2G_FDI_IR3_001_NOM.HDF.gz', WorkDir+'/FY_IR3_5km.hdf')  
        extract_gz(WorkDir+'/Z_SATE_C_BABJ_'+str(time_stamp)+'00_O_FY2G_FDI_IR4_001_NOM.HDF.gz', WorkDir+'/FY_IR4_5km.hdf')         


        progress['value'] = 40   
 
        fn = WorkDir+ '/FY_VIS_5km.hdf'

        # Open the HDF5 file in read mode
        with h5py.File(fn, 'r') as file:
            # Access the 'NOMChannelVIS' dataset
            dataset = file['NOMChannelVIS']
            # Convert the dataset to a NumPy array
            VIS = dataset[:]
            
        fn = WorkDir+ '/FY_IR1_5km.hdf'

        # Open the HDF5 file in read mode
        with h5py.File(fn, 'r') as file:
            # Access the 'NOMChannelIR1' dataset
            dataset = file['NOMChannelIR1']
            # Convert the dataset to a NumPy array
            IR1 = dataset[:]
            
        fn = WorkDir+ '/FY_IR2_5km.hdf'

        # Open the HDF5 file in read mode
        with h5py.File(fn, 'r') as file:
            # Access the 'NOMChannelIR2' dataset
            dataset = file['NOMChannelIR2']
            # Convert the dataset to a NumPy array
            IR2 = dataset[:]
            
        fn = WorkDir+ '/FY_IR3_5km.hdf'

        # Open the HDF5 file in read mode
        with h5py.File(fn, 'r') as file:
            # Access the 'NOMChannelIR3' dataset
            dataset = file['NOMChannelIR3']
            # Convert the dataset to a NumPy array
            IR3 = dataset[:]
            
        fn = WorkDir+ '/FY_IR4_5km.hdf'

        # Open the HDF5 file in read mode
        with h5py.File(fn, 'r') as file:
            # Access the 'NOMChannelIR4' dataset
            dataset = file['NOMChannelIR4']
            # Convert the dataset to a NumPy array
            IR4 = dataset[:]
            
        # create output map in ILWIS format
        data_array = np.array((VIS, IR1, IR2, IR3, IR4))    
        
        progress['value'] = 80
        
        grf = ilwis.GeoReference('code=georef:type=corners,csy=proj4:+proj=geos +a=6378137 +lon_0=104.5 +k_0=0.997800 +ellps=WGS84 +h=35785864 +rf=298.257223563, envelope=-5720000 5720000 5720000 -5720000, gridsize=2288 2288, cornerofcorners=yes')
        dfNum = ilwis.DataDefinition(ilwis.NumericDomain('code=value'), ilwis.NumericRange(0,5000, 0))
        rcNew = ilwis.RasterCoverage()
        rcNew.setSize(ilwis.Size(2288,2288,5))
        rcNew.setGeoReference(grf)
        rcNew.setDataDef(dfNum)
        
        rcNew.array2raster(data_array.flatten())
        
        rcNew = ilwis.do('mapcalc', 'iff((@1>0)and(@1<5000),@1,?)', rcNew) # remove background
        rcNew.store(OutFileName+'.mpl')

        progress['value'] = 100
        
        button0.config(state='normal')
        button1.config(state='normal')

#redundant files deleted in main menu script

def executeInThread(GNCDir, InFileName, WorkDir, OutFileName):
    button0.config(state='disabled')
    button1.config(state='disabled')
    thread = Thread(target = execute, args = (GNCDir, InFileName, WorkDir, OutFileName))
    thread.start()



# for command=doNothing
def doNothing():
   text="Do nothing button"
   return


# for command=clickthumbn
def clickthumbn():
   novi = Toplevel(app)
   novi.title ('Example of imported FY2G - Low Resolution IR image (in ILWIS)')
   novi.iconbitmap(gnc_path +'\pics\gnc.ico')
   canvas = Canvas(novi, width = 400, height = 400)
   canvas.pack(expand = YES, fill = BOTH)
   gif1 = PhotoImage(file = gnc_path +'\pics\FY2G_IRlow.gif')
   canvas.create_image(0, 0,image = gif1, anchor = NW)
   canvas.gif1 = gif1

# for command=clickAbout
def clickAbout(): 
   filewin = Toplevel(app)
   filewin.title ('About FY2G - VIS-IR')
   filewin.iconbitmap(gnc_path +'\pics\gnc.ico')
   filewin.geometry("575x340")
   msg = Message(filewin, text="""FY2G Low Resolution VIS-IR background:

Full disk image of the Low Resolution (5 km) Visible and IR1-4 channels from the Chinese geostationary satellite FengYun 2G, situated at 104.5 degree East. No data calibration can be performed as no information is provided in the meta-data. Quality of geometry is established by trial and eror and is as good as it gets!

File name convertion: Z_SATE_C_BABJ_20250126050000_O_FY2G_FDI_IR*_001_NOM.HDF.gz / Z_SATE_C_BABJ_20250126050000_O_FY2G_FDI_VIS_001_NOM.HDF.gz
Number of segments: total of 5 body segment, IR1, IR2, IR3, IR4 and VIS
Temporal Resolution: 1 hour
Initial file format: HDF5

Data is provided throught EUMETCast reception. For Legal Constraints check the 'Product Navigator' at EUMETSAT available at http://navigator.eumetsat.int
""")
   msg.pack()


#main()
#automatically setting of path when running this script from main menu - uncomment to make active   
gnc_path = os.environ["gnc_popup"]

#check path
print (gnc_path)
app = Tk()
app.title("Fengyun 2G Low resolution Visible and IR channel import routine")
app.iconbitmap(gnc_path +'\pics\gnc.ico')

w = 650 # width for the Tk app
h = 210 # height for the Tk app

app.geometry('%dx%d' % (w, h))
app.resizable(0,0)

labelText1 = StringVar()
labelText1.set ("""FY2G Low Resolution
Typical filename: Z_SATE_C_BABJ_20250126050000_O_FY2G_FDI_<spectral-channel>_001_NOM.HDF.gz""")

label1 = Label(app, textvariable=labelText1, anchor='w', justify = LEFT)
label1.pack(side = LEFT)
label1.place(x = 10, y = 5, width=650, height=35)

L1 = Label(app, text="Input Directory:", anchor='w')
L1.pack(side = LEFT)
L1.place(x = 10, y = 50, width=150, height=25)

inputDir = StringVar()
E1 = Entry(app, textvariable=inputDir, bd =2)
E1.pack()
E1.place(x = 165, y = 50, width=445, height=25)

button_dirin = Button(app, text="....", width=2, command = lambda: inputDir.set(askdirectory(initialdir = inputDir.get())))
button_dirin.pack()
button_dirin.place(x = 615, y = 49)

L2 = Label(app, text="Time Stamp (in UTC-time):", anchor='w')
L2.pack(side = LEFT)
L2.place(x = 10, y = 80, width=150, height=25)

inputFile = StringVar()
E2 = Entry(app, textvariable=inputFile, bd =2)
E2.pack()
E2.place(x = 165, y = 80, width=445, height=25)

#button_filein = Button(app, text="....", width=2, command = lambda: inputFile.set(askopenfilename(initialdir = inputDir.get()).split('/')[-1]))
#button_filein.pack()
#button_filein.place(x = 615, y = 79)

L3 = Label(app, text="Output Directory:", anchor='w')
L3.pack(side = LEFT)
L3.place(x = 10, y = 110, width=150, height=25)

outputDir = StringVar()
E3 = Entry(app, textvariable=outputDir, bd =2)
E3.pack()
E3.place(x = 165, y = 110, width=445, height=25)

button_dirout = Button(app, text="....", width=2, command = lambda: outputDir.set(askdirectory(initialdir = outputDir.get())))
button_dirout.pack()
button_dirout.place(x = 615, y = 109) 

L4 = Label(app, text="Output Filename:", anchor='w')
L4.pack(side = LEFT)
L4.place(x = 10, y = 140, width=150, height=25)

outputFile = StringVar()
E4 = Entry(app, textvariable=outputFile, bd =2)
E4.pack()
E4.place(x = 165, y = 140, width=445, height=25)

button0 = Button(app, text="Quit", width=15, command=app.destroy)
button0.pack()
button0.place(x = 525, y = 180)

button1 = Button(app, text="Execute", width=15, command=lambda: executeInThread(inputDir.get(), inputFile.get(), outputDir.get(), outputFile.get()))
button1.pack()
button1.place(x = 405, y = 180)

button2 = Button(app, text="About FY2G", width=15, command=clickAbout)
button2.pack()
button2.place(x = 285, y = 180)

button3 = Button(app, text="Thumbnail", width=15, command=clickthumbn)
button3.pack()
button3.place(x = 165, y = 180)


style = Style()
style.theme_use('clam')
style.configure('blue.Horizontal.TProgressbar', foreground='blue', background='blue')

progress = Progressbar(app, style='blue.Horizontal.TProgressbar', orient=HORIZONTAL, length=100, mode='determinate')
progress.pack()
progress.place(x = 10, y = 180)


app.mainloop()

print("inputFile=" + inputFile.get())
print("outputDir=" + outputDir.get())
print("outputFile=" + outputFile.get())



