#HSAF H26 SM DAS import routine
from tkinter import *
from tkinter.filedialog import askdirectory
from tkinter.filedialog import askopenfilename
from tkinter.ttk import Progressbar, Style
import os
import sys
import shutil
import glob


import ilwis
import netCDF4 as nc
from threading import Thread
import numpy as np



#passing parameters from sub menu

def execute(GNCDir, InFileName, WorkDir, OutFileName):
    if len(GNCDir) > 0 and len(InFileName) > 0 and len(WorkDir) > 0 and len(OutFileName) > 0:

        progress['value'] = 0
        time_stamp_in = InFileName
        timeA = time_stamp_in[:8]
        timeB = time_stamp_in[8:12]
        
        progress['value'] = 10
        
        os.chdir(WorkDir)
        ilwis.setWorkingCatalog(WorkDir)
        
        #filename expected =  S-HSAF-h26_2025040900_R01.nc
        for filename in glob.glob(os.path.join(GNCDir+'/S-HSAF-h26_'+InFileName[:10]+'_R01.nc')):
            shutil.copy(filename, WorkDir)
        
        progress['value'] = 20
    
        ds = nc.Dataset(WorkDir+'/S-HSAF-h26_'+InFileName[:10]+'_R01.nc')           

        progress['value'] =40
        
        data = ds['var40'] #forvar40, var41, var42 and var43
        data_new = np.squeeze(data)

        data_east = data_new[0:1801,0:1800]
        data_west = data_new[0:1801,1800:3600]

        var40 = np.hstack((data_west, data_east))
        min_value = np.nanmin(var40)
        var40[var40 == min_value] = -999
        
        data = ds['var41'] #forvar40, var41, var42 and var43
        data_new = np.squeeze(data)

        data_east = data_new[0:1801,0:1800]
        data_west = data_new[0:1801,1800:3600]

        var41 = np.hstack((data_west, data_east))
        min_value = np.nanmin(var41)
        var41[var41 == min_value] = -999
        
        data = ds['var42'] #forvar40, var41, var42 and var43
        data_new = np.squeeze(data)

        data_east = data_new[0:1801,0:1800]
        data_west = data_new[0:1801,1800:3600]

        var42 = np.hstack((data_west, data_east))
        min_value = np.nanmin(var42)
        var42[var42 == min_value] = -999
        
        data = ds['var43'] #forvar40, var41, var42 and var43
        data_new = np.squeeze(data)

        data_east = data_new[0:1801,0:1800]
        data_west = data_new[0:1801,1800:3600]

        var43 = np.hstack((data_west, data_east))
        min_value = np.nanmin(var43)
        var43[var43 == min_value] = -999
               
        progress['value'] = 60
        
        rcAll = np.array([var40,var41,var42,var43])
        
        #create output map in ILWIS format
        grf = ilwis.GeoReference('code=georef:type=corners, csy=epsg:4326, envelope=-180 90 180 -90, gridsize=3600 1801, cornerofcorners=yes')
        dfNum = ilwis.DataDefinition(ilwis.NumericDomain('code=value'), ilwis.NumericRange(0, 1, 0))
        rc = ilwis.RasterCoverage()
        rc.setSize(ilwis.Size(3600,1801,4))
        rc.setGeoReference(grf)
        rc.setDataDef(dfNum)

        rc_4l = rcAll.flatten()
        rc.array2raster(rc_4l)
        
        progress['value'] = 80
        
        rc_cor = ilwis.do('mapcalc','iff(@1<=-999,?,@1)',rc)
        rc_cor.store(OutFileName+'.mpl')

        #Other redundant files are deleted in main menu script
        progress['value'] = 100
        
        button0.config(state='normal')
        button1.config(state='normal')

def executeInThread(GNCDir, InFileName, WorkDir, OutFileName):
    button0.config(state='disabled')
    button1.config(state='disabled')
    thread = Thread(target = execute, args = (GNCDir, InFileName, WorkDir, OutFileName))
    thread.start()



# for command=doNothing
def doNothing():
   text="Do nothing button"
   return


# for command=clickthumbn
def clickthumbn():
   novi = Toplevel(app)
   novi.title ('Example of visualized HSAF - H26 image (in ILWIS)')
   novi.iconbitmap(gnc_path +'\pics\gnc.ico')
   canvas = Canvas(novi, width = 838, height = 400)
   canvas.pack(expand = YES, fill = BOTH)
   gif1 = PhotoImage(file = gnc_path +'\pics\HSAF_H26.gif')
   canvas.create_image(0, 0,image = gif1, anchor = NW)
   canvas.gif1 = gif1

# for command=clickAbout
def clickAbout(): 
   filewin = Toplevel(app)
   filewin.title ('About H26')
   filewin.iconbitmap(gnc_path +'\pics\gnc.ico')
   filewin.geometry("575x340")
   msg = Message(filewin, text="""HSAF H26B background:

Metop ASCAT NRT Root Zone Soil Moisture Profile Index 10km resolution. Analysed liquid soil moisture profile index for four different soil layers (covering the root zone from the surface to ~ 3 metres) generated by the ECMWF soil moisture assimilation system at 24 hour time steps. The analysed soil moisture fields are based on a modelled first guess, the screen-level temperature and humidity analyses, and the ASCAT-derived surface soil moisture. They are then re-scaled soil wetness index by normalising by the saturated soil moisture value as a function of soil type. The Global product is generated starting from the EUMETCast SSM product. Resolution: HR: 0.1 degrees (~10km) - VR: 4 layers in the range surface to 2.89m: layer-1 (0-7cm), layer-2 (7- 28cm), layer-3 (28-100cm) and layer-4 (100-289cm).

File name convertion: S-HSAF-h26_2025040900_R01.nc
Number of segments: 1 file
Temporal resolution: 1 per day, starting from 00:00 UTC
Initial file format: nc format

Data is provided throught EUMETCast reception. For Legal Constraints check the 'Product Navigator' at EUMETSAT available at http://navigator.eumetsat.int
""")
   msg.pack()


#main()
#automatically setting of path when running this script from main menu - uncomment to make active   
gnc_path = os.environ["gnc_popup"]

#check path
print (gnc_path)
app = Tk()
app.title("HSAF H26B")
app.iconbitmap(gnc_path +'\pics\gnc.ico')

w = 650 # width for the Tk app
h = 210 # height for the Tk app

app.geometry('%dx%d' % (w, h))
app.resizable(0,0)

labelText1 = StringVar()
labelText1.set ("""HSAF H26B import routine   
Typical filename: S-HSAF-h26_2025040900_R01.nc""")

label1 = Label(app, textvariable=labelText1, anchor='w', justify = LEFT)
label1.pack(side = LEFT)
label1.place(x = 10, y = 5, width=650, height=35)

L1 = Label(app, text="Input Directory:", anchor='w')
L1.pack(side = LEFT)
L1.place(x = 10, y = 50, width=150, height=25)

inputDir = StringVar()
E1 = Entry(app, textvariable=inputDir, bd =2)
E1.pack()
E1.place(x = 165, y = 50, width=445, height=25)

button_dirin = Button(app, text="....", width=2, command = lambda: inputDir.set(askdirectory(initialdir = inputDir.get())))
button_dirin.pack()
button_dirin.place(x = 615, y = 49)

L2 = Label(app, text="Time Stamp (in UTC-time):", anchor='w')
L2.pack(side = LEFT)
L2.place(x = 10, y = 80, width=150, height=25)

inputFile = StringVar()
E2 = Entry(app, textvariable=inputFile, bd =2)
E2.pack()
E2.place(x = 165, y = 80, width=445, height=25)

#button_filein = Button(app, text="....", width=2, command = lambda: inputFile.set(askopenfilename(initialdir = inputDir.get()).split('/')[-1]))
#button_filein.pack()
#button_filein.place(x = 615, y = 79)

L3 = Label(app, text="Output Directory:", anchor='w')
L3.pack(side = LEFT)
L3.place(x = 10, y = 110, width=150, height=25)

outputDir = StringVar()
E3 = Entry(app, textvariable=outputDir, bd =2)
E3.pack()
E3.place(x = 165, y = 110, width=445, height=25)

button_dirout = Button(app, text="....", width=2, command = lambda: outputDir.set(askdirectory(initialdir = outputDir.get())))
button_dirout.pack()
button_dirout.place(x = 615, y = 109) 

L4 = Label(app, text="Output Filename:", anchor='w')
L4.pack(side = LEFT)
L4.place(x = 10, y = 140, width=150, height=25)

outputFile = StringVar()
E4 = Entry(app, textvariable=outputFile, bd =2)
E4.pack()
E4.place(x = 165, y = 140, width=445, height=25)

button0 = Button(app, text="Quit", width=15, command=app.destroy)
button0.pack()
button0.place(x = 525, y = 180)

button1 = Button(app, text="Execute", width=15, command=lambda: executeInThread(inputDir.get(), inputFile.get(), outputDir.get(), outputFile.get()))
button1.pack()
button1.place(x = 405, y = 180)

button2 = Button(app, text="About H26", width=15, command=clickAbout)
button2.pack()
button2.place(x = 285, y = 180)

button3 = Button(app, text="Thumbnail", width=15, command=clickthumbn)
button3.pack()
button3.place(x = 165, y = 180)


style = Style()
style.theme_use('clam')
style.configure('blue.Horizontal.TProgressbar', foreground='blue', background='blue')

progress = Progressbar(app, style='blue.Horizontal.TProgressbar', orient=HORIZONTAL, length=100, mode='determinate')
progress.pack()
progress.place(x = 10, y = 180)


app.mainloop()

print("inputFile=" + inputFile.get())
print("outputDir=" + outputDir.get())
print("outputFile=" + outputFile.get())


